#pragma once

#include <stdio.h>
#include "unzip.h"

#define MAGIC "NISLFILE"

typedef struct _StringItem {
    /**
     * ַַ
     */
    unsigned int size;

    /**
     * ַ顣
     */
    unsigned char* str;
} StringItem;

typedef struct _YcHeader {
    /**
     * ħ֡
     */
    const char* magic;

    /**
     * ļͷȡ
     */
    unsigned int size;

    /**
     * Methodṹĸ
     */
    unsigned int methodSize;

    /**
     * Methodݾļʼƫơ
     */
    unsigned int methodOffset;

    /**
     * SeparatorDataṹĸ
     */
    unsigned int separatorDataSize;

    /**
     * SeparatorDataݾļʼƫơ
     */
    unsigned int separatorDataOffset;
    /**
     * StringItemܴСռֽ
    */
    unsigned int stringItemSize;
    /**
     * StringItemƫ
     */
    unsigned int stringItemOffest;
    /**
     * TypeItemṹĴС
     */
    unsigned int typeItemSize;
    /**
     * TypeItem ṹƫ
     */
    unsigned int typeItemOffest;
    /**
     * methodṹĴС
     */
    unsigned int methodItemSize;
    /**
     * methodItemṹƫ
     */
    unsigned  int methodItemOffest;
    /**
     * fieldṹĴС
     */
    unsigned int fieldItemSize;
    /**
     * fieldItemṹƫ
     */
    unsigned int fieldItemOffset;

} YcHeader;

typedef struct _AdvmpMethod {

    /**
     * method_id_itemе
     */
    int methodIndex;

    unsigned int size;

    /**
     * ķʱ־
     */
    unsigned int accessFlag;

    /**
     * ࡣ
     * "Ljava/lang/System;"ĸʽ档
     */
     char* definingClass;

    /**
     * 
     */
     char* name;

    /**
     * ǩ
     */
     char* sig;
} AdvmpMethod;

typedef struct _SeparatorData {

    /**
     * ʾǰSeparatorDataṹ
     * SeparatorDataṹе
     */
    unsigned int methodIndex;

    /**
     * ǰṹĴС
     */
    unsigned int size;

    /**
     * ķʱ־
     */
    unsigned int accessFlag;

    /**
     * 
     */
    unsigned int paramSize;

    /**
     * Ĵ
     */
    unsigned int registerSize;

    /**
     * Ķ
     */
    StringItem paramShortDesc;

    /**
     * ָԪظ
     */
    unsigned int instSize;

    /**
     * ȡķָ
     */
    unsigned short* insts;

    /**
     * try...catch顣
     */
    //public List<TryBlock> tryBlocks;

    /**
     * debugϢ
     */
    //public List<DebugItem> debugItems;

} SeparatorData;

struct MethodItem
{
    unsigned int classnameIdx;
    unsigned int protoIdx;
    unsigned int methodnameIdx;
};
struct FieldItem
{
    unsigned int classNameIdx;
    unsigned int fieldNameIdx;
    unsigned int typeIdx;

};

class YcFormat {
public:
    /**
     * ļͷ
     */
    YcHeader header;

    /**
     * һָ顣
     */
    AdvmpMethod** methods;

    char ** mStringItem;

    int *mTypeItem;
    struct MethodItem *mMethodItem;
    struct FieldItem *mFieldItem;

    /**
     * ݡ
     * һָ顣
     */
    SeparatorData** separatorDatas;

    YcFormat();
    ~YcFormat();
};

//////////////////////////////////////////////////////////////////////////

class YcFile {
public:
    YcFile();
    YcFile(const char* filePath);

    ~YcFile();

    /**
     * Ycļ
     * @return trueɹfalseʧܡ
     */
    //bool parse();

    /**
     * Ycļ
     * @param[in] ycData ycļݡ
     * @param[in] dataSize ݳȡ
     * @return trueɹfalseʧܡ
     */
    bool parse(unsigned char* ycData, size_t dataSize);

    /**
     * ڴеYcļ
     * @param[in] ڴеYcļݡ
     * @return trueɹfalseʧܡ
     */
    bool parse(unsigned char* bytes);

    YcFormat mYcFormat;

    /**
     * Separatorݡ
     * @param[in] index SeparatorDataе
     * @return Separatorݡ
     */
    const SeparatorData * GetSeparatorData(int index);

private:
    char* mFilePath;
};

/**
 * ͷNISLļ
 * @param[in] filePath zipļ·
 * @param[out] buffer NISLļݡ
 * @return ɹNISLļĳȡʧܡ0
 * @note bufferҪfreeͷڴ档
 */
uLong ReleaseYcFile(const char* zipPath, unsigned char** buffer);

/**
 * 򿪲ycļ
 * @return trueɹfalseʧܡ
 */
//bool OpenAndParseYc();
