package lz.android.shell.advmpformat;

import lz.android.shell.processins.DexFileFormat;

import java.util.List;


public class Format {
//public  static  final String MAGIC="YC0000";
    public static final String MAGIC = "NISLFILE";
   // public static final int SIZE_HEADER = MAGIC.length() + 4 + 4 + 4 + 4 + 4;

    public static final int SIZE_HEADER = MAGIC.length() + 4 + 4 + 4 + 4 + 4+6*4 +4+4;//+4+4 11 months 30 number is added, The Write field Size and Offset

    /**
* The file header.
*/
    public Header header;

    /**
*
*/
public List<AdvmpMethod> methods;

/**
* Pulled data.
*/
    public List<SeparatorData> separatorDatas;

    /**
* Extract the instruction to be used in the String
*/
    public List<DexFileFormat.StringData> stringDatas;

    /**
* Extract the instruction to be used of the Type
*/
    public List<DexFileFormat.TypeItemDate> typeItemDates;
    /**
* Extract the instruction to be used in the Field
*/
    public  List<DexFileFormat.FieldItemDate> fieldItemDates;

    /**
* Extract the instruction to be used in the Method
*/
    public List<DexFileFormat.MethodItemDate> methodItemDates;

    public static class Header {

        /**
* Magic word.
*/
        public String magic;

        /**
* File head size.
*/
        public int size;

        /**
* Method of the structure of the number.
*/
        public int methodSize;

        /**
* Method data from a file starting offset.
*/
        public int methodOffset;

        /**
* SeparatorData structure of the number.
*/
        public int separatorDataSize;

        /**
* SeparatorData data from a file starting offset.
*/
        public int separatorDataOffset;
        /**
* StringItem, the total size, which represents how many bytes
*/
        public int stringItemSize;
        /**
* StringItem starting offset
*/
        public int stringItemOffset;
        /**
* TypeItem the size of the structure
*/
        public int typeItemSize;
        /**
* TypeItem the starting offset
*/
        public int typeItemOffest;
        /**
* methodItem the size of the structure
*/
        public int methodItemSize;
        /**
* methodItem the starting offset
*/
        public int methodItemOffest;
        /**
* Field the size of the structure
*/
        public  int fieldItemSize;
        /**
* Field structure of the starting offset
*/
        public int fieldItemOffset;

    }

    /**
*
* This class is a field in the corresponding dex file in the appropriate method.
* These information to ensure that the advmp in the invoke method, you can
* By jni function to find the method.
*/
    public static class AdvmpMethod {

        /**
* Method in the dex index.
*/
        public int methodIndex;

        /**
* The current structure size.
*/
        public int size;

        /**
* The method's access flags.
*/
        public int accessFlag;

        /**
* The method belongs to the class.
* In the"java/lang/System"so that the format of the save.
*/
        public StringItem definingClass;

        /**
* The method name.
*/
        public StringItem name;

        /**
* Method signature.
*/
        public StringItem sig;
    }

    /**
* TODO this structure should be reduced.
* Pulled data.
*/
    public static class SeparatorData {

        /**
* This index represents the current SeparatorData structure in
* SeparatorData structure in the array index.
*/
        public int methodIndex;

        /**
* The current structure size.
*/
        public int size;

        /**
* The method's access flags.
*/
        public int accessFlag;

        /**
* The parameter number.
*/
        public int paramSize;

        /**
* The register number.
*/
        public int registerSize;

        /**
* Parameter of the short type description.
*/
        public StringItem paramShortDesc;

        /**
* Instruction array element number.
*/
        public int instSize;

        /**
* Extracted by method of instruction.
*/
        public short[] insts;

        /**
* Method in a try...catch block.
*/
        //public List<TryBlock> tryBlocks;

        /**
* Method of the debug information.
*/
        //public List<DebugItem> debugItems;

    }

}

