package lz.android.shell.base.helper;

import java.io.*;
import java.nio.file.Files;


public class ResourceHelper {

    /**
* The resource is copied to the destination address.
* @param clazz Class object.
* @param resPath the resource in the jar in the path.Such as:"resources/a.txt"it.
* @param outFile output file path.
* @throws IOException
*/
    public static void copyResource(Class clazz, String resPath, File outFile) throws IOException {
        try (BufferedInputStream in = new BufferedInputStream(clazz.getClassLoader().getResourceAsStream(resPath))) {
            Files.copy(in, outFile.toPath());
        }
    }

    /**
* Access to resources of the text content.
* @param clazz Class object.
* @param resPath the resource in the jar in the path.Such as:"resources/a.txt"it.
* @throws IOException
*/
    public static String getResourceTxt(Class clazz, String resPath) throws IOException {
        StringBuffer sb = new StringBuffer();
        InputStream is = clazz.getClassLoader().getResourceAsStream(resPath);

        try (BufferedInputStream in = new BufferedInputStream(is)) {
            int byteRead = 0;
            byte[] buffer = new byte[1024];

            while ((byteRead = in.read(buffer)) != -1) {
                sb.append(new String(buffer, 0, byteRead));
            }
        }
        return sb.toString();
    }

}

