package lz.android.shell.controlcentre;



import org.apache.commons.cli.*;
import org.apache.log4j.*;

import java.io.*;
import java.util.Scanner;


/**
 * Created by buwai on 2015/4/1.
 */
public class EntryPoint {

    private final static Logger log = Logger.getLogger(EntryPoint.class);


    private static Options options;

    static {
        options = new Options();
        options.addOption("h", false, "use the help");
        options.addOption("s", true, "apk file path.");
        options.addOption("o", true, "output directory");
    }

    public static void main(String[] args) {
        log.info("------ Go to the Control Center------");
        try {
            BasicParser parser = new BasicParser();
            CommandLine cl = null;
            cl = parser.parse(options, args);

            if (cl.hasOption('h')) {
                usage();
            }

            ControlCentreOption opt = new ControlCentreOption();
            if (cl.hasOption('s')) {
                opt.apkFile = new File(cl.getOptionValue('s'));
            }
            if (null == opt.apkFile) {
                usage();
            }

            if (cl.hasOption('o')) {
                opt.outDir = new File(cl.getOptionValue('o'));
            }
            if (null == opt.outDir) {
                usage();
            }

            ControlCentre controlCentre = new ControlCentre(opt);
            System.out.print("Please input you want to protect the name of the class(eg:com.example.lz.advmptesteasy.MainActivity):");
            Scanner scanner01 = new Scanner(System.in);
            String InputProtectClassName = null;
            InputProtectClassName = scanner01.next();//The input to be protected a class name
            System.out.print("Please input you want to protect the name of the method(say:add):");
            Scanner scanner02 = new Scanner(System.in);//The input to be protected a method name
            String ProtectMethodName = null;
            ProtectMethodName = scanner02.next();
            log.info("------ Go to the Control Center------");
            log.info("Start reinforcement.");
            String ProtectClassName=null;
            ProtectClassName=DealClassName(InputProtectClassName);//The class name for processing
//            Utils.copyFile(opt.apkFile.getAbsolutePath(),opt.outDir.getAbsolutePath()+File.separator+"apk_shelled.apk");
// log.info("reinforcement is completed");
            if (controlCentre.shell(ProtectClassName,ProtectMethodName,InputProtectClassName)) {
                log.info("Reinforcement is completed");
            }

        } catch (ParseException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        log.info("------ Leave the Control Center------");
    }

    private static void usage() {
        HelpFormatter help = new HelpFormatter();
        help.printHelp("-s <dex file path> -o <output directory> [-c <configuration file path>]", options);
        System.exit(-1);
    }
    public static String DealClassName(String ProtectClassName){
        ProtectClassName = ProtectClassName.replace(".","/");
        ProtectClassName = "L"+ProtectClassName+";";
        return ProtectClassName;
    }
}

