package lz.android.shell.separator;

import org.apache.commons.cli.*;
import org.apache.log4j.Logger;

import java.io.File;
import java.io.IOException;

/**
* Created by buwai on 2015/4/1.
*/
public class EntryPoint {

private static final Logger log = Logger.getLogger(EntryPoint.class);

private static Options options;

static {
options = new Options();
options.addOption("h", false, "use help");
options.addOption("s", true, "dex file path");
options.addOption("o", true, "output directory");
options.addOption("c", true, "configuration file");
}

public static void main(String[] args) {
try {
BasicParser parser = new BasicParser();
CommandLine cl = null;
cl = parser.parse(options, args);

if (cl.hasOption('h')) {
usage();
}

SeparatorOption opt = new SeparatorOption();

if (cl.hasOption('s')) {
opt.dexFile = new File(cl.getOptionValue('s'));
}
if (null == opt.dexFile) {
usage();
}

File outDir = null;
if (cl.hasOption('o')) {
outDir = new File(cl.getOptionValue('o'));
}
if (null == outDir) {
usage();
}
opt.outDexFile = new File(outDir, "classes.dex");
opt.outNISLFile = new File(outDir, "classes.yc");
opt.outCPFile = new File(outDir, "advmp_separator.cpp");

if (cl.hasOption('c')) {
opt.configFile = new File(cl.getOptionValue('c'));
}

//Utils.addLoadLibrary(srcFile, classDesc);
String ProtectClassName = null;
String ProtectMethodName = null;
log.info ("------ start extract------");
Separator separator = new Separator(opt);
if (separator.run(ProtectClassName,ProtectMethodName)) {
log.info("extraction successful.");
} else {
log.error("extraction failed.");
}
log.info ("------ extract the end------");
} catch (ParseException e) {
e.printStackTrace();
} catch (IOException e) {
e.printStackTrace();
}
}

/**
* Usage.
*/
    private static void usage() {
        HelpFormatter help = new HelpFormatter();
        help.printHelp("-s <dex file path> -o <output directory> [-c <configuration file path>]", options);
        System.exit(-1);
    }

}

