package lz.android.shell.separator.config;

import lz.android.shell.base.TypeDescription;
import org.jf.dexlib2.AccessFlags;
import org.jf.dexlib2.Opcode;

import java.util.ArrayList;
import java.util.List;

/**
* Configuration.
* When the whitelist and blacklist configuration items when there is conflict in the blacklist shall prevail.
* Created by buwai on 2015/4/1.
*/
public class Config {

    public static final String CONF_FILE_SYSTEM_PROPERTY = "system-property.conf";
    public static final String CONF_FILE_USER_DEFAULT = "user-default.conf";

    public static final String CONF_WHITE_LIST = "whitelist";
    public static final String CONF_BLACK_LIST = "blacklist";

    public static final String CONF_NON_SUPPORTS = "nonsupport";

    public static final String CONF_OPCODES = "opcodes";
    public static final String CONF_CLASS_ACC_FLAGS = "classAccFlags";
    public static final String CONF_METHOD_ACC_FLAGS = "methodAccFlags";

    public static final String CONF_TRY = "try";

    /**
* White list.
*/
    public List<TypeDescription> whiteList = new ArrayList<>();

    /**
* Blacklist - on behalf of the ban.
*/
    public List<TypeDescription> blackList = new ArrayList<>();

    /**
* Does not support class access flags.
*/
    public List<AccessFlags> nonsupportClassAccFlags = new ArrayList<>();

    /**
* Does not support the method access flags.
*/
    public List<AccessFlags> nonsupportMethodAccFlags = new ArrayList<>();

    /**
* Not supported opcode's.
*/
    public List<Opcode> nonsupportOpcodes = new ArrayList<>();

    /**
* Whether to support the method has exception handling of the case.
* true: support.false: not supported.
*/
    public boolean isSupportTryCatch;

}

