package lz.android.shell.separator.config;

import lz.android.shell.base.TypeDescription;
import lz.android.shell.base.helper.TypeDescriptionHelper;
import org.jf.dexlib2.AccessFlags;
import org.jf.dexlib2.iface.Method;

/**
* Created by buwai on 2015/4/1.
*/
public class ConfigHelper {

private Config mConfig;

public ConfigHelper (Config config) {
mConfig = config;
}

/**
* Is valid.
* @param method
* @return true: valid.false: invalid.
*/
    public boolean isValid(Method method,String Classname,String MethodName) {
        TypeDescription methodTypeDesc = TypeDescriptionHelper.convertByMethod(method);

        // Does not support the method in a try...catch it.
//        if (false == mConfig.isSupportTryCatch) {
//          // System.out.println(method.getImplementation().getRegisterCount());
////            if (0 != method.getImplementation().getTryBlocks().size()) {
////                System.out.println("Unsupported type");
//             return false;
////            }
//        }

        // Determine whether the method implementation.
        if (null == method.getImplementation()) {
            return false;
        }
        else {
            // Does not support the method in a try...catch it.
//            if (false == mConfig.isSupportTryCatch) {
//                if (0 != method.getImplementation().getTryBlocks().size()) {
//                    System.out.println("Unsupported type");
//                    return false;
//                }
//            }
        }

        // Determine whether it is a native method.
        if (0 != (method.getAccessFlags() & AccessFlags.NATIVE.getValue())) {
            return false;
        }
//
// // Not supported<clinit>
        if ("<clinit>".equals(methodTypeDesc.methodName)) {
            return false;
        }

        // Does not support the<init>
        if ("<init>".equals(methodTypeDesc.methodName)) {
            return false;
        }

        //The name of the class to judge.
        if(!Classname.equals(method.getDefiningClass())){
            return false;
        }
//        Lcom/example/lz/advmptesteasy/MainActivity;
//        ddd1
        //Other Farmington judgment.
        // TODO here for now is written to die for!
        if ((!MethodName.equals(method.getName()))) {
            return false;
        }
        // First determine the blacklist.
        if (TypeDescriptionHelper.isMatchMethodInBlackList(mConfig.blackList, methodTypeDesc)) {
            return false;
        }

        // Then determine the White list.
        if (!TypeDescriptionHelper.isMatchMethodInWhiteList(mConfig.whiteList, methodTypeDesc)) {
            return false;
        }

        return true;
    }

}

